﻿Imports Telerik.WinControls.UI

Public Class CustomPropertyGridItemElement : Inherits PropertyGridItemElement

    Private button As RadButtonElement

    Protected Overrides Sub CreateChildElements()
        MyBase.CreateChildElements()

        button = New RadButtonElement()
        button.Text = "..."
        button.StretchHorizontally = False
        button.Margin = New Padding(0, 2, 0, 2)
        button.Alignment = ContentAlignment.MiddleRight

        Me.ValueElement.Children.Add(button)

        AddHandler button.Click, AddressOf button_Click
    End Sub

    Protected Overrides Sub DisposeManagedResources()
        MyBase.DisposeManagedResources()

        RemoveHandler button.Click, AddressOf button_Click
    End Sub

    Public Overrides Sub AddEditor(editor As Telerik.WinControls.UI.IInputEditor)
    End Sub

    Public Overrides Sub RemoveEditor(editor As Telerik.WinControls.UI.IInputEditor)
    End Sub

    Public Overrides Function IsCompatible(data As Telerik.WinControls.UI.PropertyGridItemBase, context As Object) As Boolean
        Dim item As PropertyGridItem = TryCast(data, PropertyGridItem)
        Return item IsNot Nothing AndAlso item.PropertyType = GetType(String)
    End Function

    Private Sub button_Click(sender As Object, e As EventArgs)
        Dim item = TryCast(Me.Data, PropertyGridItem)
        Dim dialog As Form2 = New Form2()
        dialog.TextBoxText = item.FormattedValue
        Dim result = dialog.ShowDialog()

        If result = DialogResult.OK Then
            item.FormattedValue = dialog.TextBoxText
        End If
    End Sub

    Protected Overrides ReadOnly Property ThemeEffectiveType As System.Type
        Get
            Return GetType(PropertyGridItemElement)
        End Get
    End Property

End Class
